<template>
  <div class="container">   

    <b-row>
        <b-col cols="8">
            <b-form-input
                id="textSearch"
                v-model="textSearch"  
                @keyup.enter="listUser"
                >
            </b-form-input>
        </b-col>
        <b-col cols="4">
            <b-button variant="success" class="float-right" @click="showModal">New User</b-button>
        </b-col>
    </b-row>    

    <b-pagination class="mt-3"
     v-model="currentPage"
     :total-rows="rows"
     :per-page="perPage"
      aria-controls="tableUser"
    ></b-pagination>

    <p class="mt-3">Current Page: {{ currentPage }}</p>
       
    <b-table striped hover
      id="tableUser"
      :items="users"
      :fields="fields"
      :per-page="perPage"
      :current-page="currentPage"
      small
    >  
        <template #cell(#)="row">
            {{(row.index+1)+((currentPage-1)*perPage)}}
        </template>

        <template #cell(options)="row">
            <b-button variant="primary" size="sm" @click="getUser(row.item.id)">
                <b-icon-pencil></b-icon-pencil>
            </b-button>
            <b-button variant="danger" size="sm" @click="deleteUser(row.item.id)">
                <b-icon-trash></b-icon-trash>
            </b-button> 
        </template>

    </b-table> 

    <b-modal id="ModalUser" :okTitle="buttonText" 
     no-close-on-backdrop
     @ok="saveUser" 
     @hidden="this.resetUser"    
     size="lg"
     :title="modalTitle">
        <form ref="form">
            <b-form-group
                label="Name"
                label-for="name-input"           
            >
                <b-form-input
                id="name"  
                v-model = "user.name"   
                required
                ></b-form-input>
            </b-form-group>
            <b-form-group
                label="Email"
                label-for="email-input"
                invalid-feedback="Name is required"            
            >
                <b-form-input
                id="email" 
                v-model = "user.email" 
                required
                ></b-form-input>
            </b-form-group>
        </form>
      
    </b-modal>

  </div>
  
  
</template>

<script>
  export default {
    data() {
      return {
        perPage: 5,
        currentPage: 1,        
        users:[],
        fields:['#','name', 'email', 'options'],
        user:{
            id:'',
            name:'',
            email:''
        },
        textSearch:'',
        modalTitle:'',
        buttonText:'',
      }
    },
    created(){
        this.listUser();
    },
    methods: {
        listUser(){                
            axios.get(`user/list/${this.textSearch}/`).then(res =>{
                this.users = res.data;                                              
            }).catch(error => {  
                this.$alertify.error("Something is wrong")
                this.users = [];               
            });
        },
        saveUser(bvModalEvt){
            bvModalEvt.preventDefault();            
            if(this.user.id==='')  
                this.createUser();
            else
                this.updateUser();              
        },
        createUser(){            
            axios.post('/user/create',this.user).then(res =>{            
                this.$alertify.success(res.data.message);
                this.$bvModal.hide('ModalUser');
                this.listUser();      
            }).catch(error => {                
                if(error.response.data.errors!=null){
                    Object.entries(error.response.data.errors).forEach(([key, value]) => {   
                        this.$alertify.warning(value+'');
                    });
                }
                else{
                    this.$alertify.error("Something is wrong")
                }
            })
            
        },
        updateUser(){
            axios.post('/user/update',this.user).then(res =>{
                this.$alertify.success(res.data.message);
                this.textSearch = '';
                this.listUser();
                this.$bvModal.hide('ModalUser');
            }).catch(error => {
                if(error.response.data.errors!=null){
                    Object.entries(error.response.data.errors).forEach(([key, value]) => {   
                        this.$alertify.warning(value+'');
                    });
                }
                else{
                    this.$alertify.error("Something is wrong");
                }
            });
        },
        deleteUser(id){
            axios.post(`/user/delete/${id}`)
            .then(res=>{
                this.$bvModal.hide('ModalUser');
                this.$alertify.success(res.data.message);
                this.listUser();
            }).catch(error => { 
                this.$alertify.error(error.response.status == 402?error.response.data.message:"Something is wrong");              
            });
        },
        getUser(id){
            axios.get(`/user/get/${id}`)
            .then(res =>{
                this.user = res.data;                
                this.showModal();
            }).catch(error => {  
                this.$alertify.error("Something is wrong");             
            });
        },
        showModal(){
            this.modalTitle = this.user.id === '' ? "New User" : "Update User - "+this.user.name;
            this.buttonText = this.user.id === '' ? "Save" : "Update"
            this.$bvModal.show('ModalUser');
        },
        resetUser(){
            this.user = {
                id:'',
                name:'',
                email:''
            }
        }
    },
    computed: {
      rows() {
        return this.users.length
      }
    }
  }
</script>